#include "aiapi/irensei_rule_description.h"
#include "aiapi/irensei_ai_descripter.h"
#include "aiapi/game.h"
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

//																		//
//						DLL C^[tF[X							//

extern "C" __declspec(dllexport) int IrenseiGetName( char dest[IRENSEI_AI_NAME_LEN] )	{ strcpy( dest, "random(hsp sample)" ); return 0; }
extern "C" __declspec(dllexport) int IrenseiGetFirstVersion( void )		{ return 100; }
extern "C" __declspec(dllexport) int IrenseiGetLastVersion( void )		{ return 100; }

extern "C" __declspec(dllexport) int IrenseiInitialize(const IRENSEI_RULE_DESCRIPTION * rule, int side, int hout)
{
	if ( ! CheckIrenseiRuleDescriptionValidity( rule ) )
		return 0;

	FILE * fp = fopen( "aiside.bin", "wb" );			// HSP ɓnԏ
	if ( ! fp )
		return 0;
	unsigned char s = static_cast<unsigned char>( side );
	fwrite( &s, 1, 1, fp );
	fclose( fp );

	IrenseiPrintf( reinterpret_cast<HANDLE>(hout), "random(hsp) AI initialized.\n" );
	Irensei::Game * game = new Irensei::Game;
	game->SetRule( *rule );
	return reinterpret_cast<int>( game );
}

extern "C" __declspec(dllexport) int IrenseiFinalize(int param, int hout)
{
	delete reinterpret_cast< Irensei::Game * >( param );
	IrenseiPrintf( reinterpret_cast<HANDLE>(hout), "random(hsp) AI finalized.\n" );
	system( "del aiside.bin" );
	return 1;
}

extern "C" __declspec(dllexport) int IrenseiThink(int param, IRENSEI_BOARD_POSITION * result, const IRENSEI_BOARD_POSITION * lastMove, int hout)
{
	system( "del airesult.bin" );
	FILE * fp = fopen( "aiboard.bin", "wb" );			// HSP ɓnՖʏ
	if ( ! fp )
		return 0;

	Irensei::Game * const game = reinterpret_cast< Irensei::Game * >( param );
	if ( lastMove )
		game->NewMove( lastMove->x, lastMove->y );

	const Irensei::Board * const board = game->GetBoard();
	fwrite( board, 1, sizeof(Irensei::Board), fp );
	fclose( fp );

	if ( 0 == (fp = fopen( "airesult.bin", "wb" )) )	// HSP ނ߂̃t@C쐬Ă
		return 0;
	fclose( fp );
	if ( 0 == (fp = fopen( "aiend.bin", "wb" )) )		// HSP Ip̃t@C
		return 0;
	fclose( fp );

	system( "hsptmp.exe" );

	while ( 0 != (fp = fopen( "aiend.bin", "rb" ) ) ) {	// HSP I
		fclose( fp );
		Sleep( 500 );
	}

	if ( 0 == (fp = fopen( "airesult.bin", "rb" )) )	// HSP ̏o
		return 0;

	fread( result, 8, 1, fp );
	game->NewMove( result->x, result->y );
	fclose( fp );

	return 1;
}


